///////////////////////////////////////////////////////////////////////////////
// The EFestivalsClient class implements a simple RSS fetcher and parser.

// Constructor.
function EFestivalsClient() {
    this.httpReq = null;
    this.callback = null;
}

EFestivalsClient.prototype.fetchXML = function(url, callback) {
    // remember callback
    this.callback = callback;
    
    // create new XML HTTP request
    this.httpReq = new Ajax();
    // set callback
    var self = this;
    this.httpReq.onreadystatechange = function() { self.readyStateChanged(); };
    // initiate the request
    this.httpReq.open("GET", url, true);
    this.httpReq.send(null);
}

// Callback for ready-state change events in the XML HTTP request.
EFestivalsClient.prototype.readyStateChanged = function() {
    // complete request?
	
    if (this.httpReq.readyState == 4) {
        // attempt to get response status
        var responseStatus = null;
        try {
            responseStatus = this.httpReq.status;
        } catch (noStatusException) {}
        
        // handle the response and call the registered callback
        this.callback.call(this, this.handleResponse(responseStatus, this.httpReq.responseXML));
    }
}

// Handles a completed response.
EFestivalsClient.prototype.handleResponse = function(responseStatus, xmlDoc) {
	//alert('handleResponse A '+responseStatus);
    if (responseStatus == 200 && xmlDoc != null) {
        // node ref for iterating
        var item;   
        // init feed items array
        var items = [];		
		var itemTitle;
		var itemDescription;
		var itemLink;
		var itemPubDate;
		
		var events = xmlDoc.getElementsByTagName("item");		
		if (events != null && events.length > 0) {
			//alert('handleResponse B '+events.length);
			for (var i = 0; i < events.length; i++) {
				
				item = events[i];
				//alert('handleResponse B1');
				var tmpElement = item.getElementsByTagName('title').item(0);
				//alert(titleTab.firstChild.data);

				itemTitle = tmpElement.firstChild.data;//item.attributes.getNamedItem("title").value;
				//alert('handleResponse B2');
				tmpElement = item.getElementsByTagName('description').item(0);
				itemDescription = tmpElement.firstChild.data;//item.attributes.getNamedItem("description").value;
				//alert('handleResponse B3');
				tmpElement = item.getElementsByTagName('link').item(0);
				itemLink = tmpElement.firstChild.data;//item.attributes.getNamedItem("link").value;
				//alert('handleResponse B4');
				tmpElement = item.getElementsByTagName('pubDate').item(0);
				itemPubDate = tmpElement.firstChild.data;//item.attributes.getNamedItem("pubDate").value;
				//alert('handleResponse B5');
				items.push({
					itemTitle: itemTitle,
					itemDescription: itemDescription,
					itemLink: itemLink,
					itemPubDate: itemPubDate
				});
			}
			//alert('handleResponse C');
		}
			//alert('handleResponse D');       
        // update was completed successfully
        return { status: "ok", items: items };
    } else {
		//alert('handleResponse update failed');
        // update failed
        return { status: "error" };
    }
}
