// Constructor.
function OwnButton(id, text) {
    if (id != UI_NO_INIT_ID) {
        this.init(id, text);
    }
}

// OwnButton inherits from ActionControl.
OwnButton.prototype = new ActionControl(UI_NO_INIT_ID);

// Button text element.
OwnButton.prototype.textElement = null;

OwnButton.prototype.locked = false;

OwnButton.prototype.setLocked = function(lck){
	this.locked = lck;
	this.setClassName(this.controlElement, this.id+ ((lck) ? "Pressed" : "")); 
}

// Initializer - called from constructor.
OwnButton.prototype.init = function(id, text) {
    uiLogger.debug("OwnButton.init(" + id + ", " + text + ")");
    
    // call superclass initializer
    ActionControl.prototype.init.call(this, id, null);
    
    // remove caption element
    this.assemblyElement.removeChild(this.captionElement);
    
    // construct the button
    this.buttonElement = document.createElement("div"); 
    this.linkElement = document.createElement("a");
    this.linkElement.href = "JavaScript:void(0)";
    this.textElement = document.createElement("div");
	this.setClassName(this.buttonElement, id + "Area");
	this.setClassName(this.textElement, id +"Content");
	
 	this.textElement.innerHTML = "&nbsp;";
 	this.controlElement.appendChild(this.buttonElement);
 	this.buttonElement.appendChild(this.linkElement);
 	this.linkElement.appendChild(this.textElement);
	
	this.setClassName(this.controlElement, id); 
      
    // bind event listeners
    this.bindActionControlListeners(); 

 	this.bindOwnListeners();	  
}

OwnButton.prototype.bindOwnListeners = function() {
    var self = this;
		
	this.buttonElement.addEventListener("mouseout", function(event){		
		self.setClassName(self.controlElement, self.id + ((self.locked) ? "Pressed" : ""));
	}, true);
	this.buttonElement.addEventListener("mousedown", function(event){
		self.setClassName(self.controlElement, self.id + ((self.locked) ? "Pressed" : ""));
	}, true);
	this.buttonElement.addEventListener("mousemove", function(event){
		self.setClassName(self.controlElement, self.id + "Pressed");
	}, true);
}
